C     PROGRAM AVSONE
      DOUBLE PRECISION X,EPS,THRESH,H,HMIN,XP,YP,DELTY,RO,YX2,AU,AJK,
     1                 AU2,AJK2,XJ0,XJ02,AJKP,U,U2,ZFI,ZFI2,HD4I,RABC,
     2                 ALP,ALPN,CMAR,P,S,ALP2,ALPN2,CMAR2,
     3                 WC1,WC2,WC3,HD2,HD4,HOLD,WC30,WC12,WC22,WC32 
C
C
      LOGICAL BUL
C
      PARAMETER (K=18,K2=25,M=1)
      DIMENSION XJ0 (K), AU (M,K+2), AJK (M,K+1), 
     1          XJ02(K2),AU2(M,K2+2),AJK2(M,K2+1),
     2          AJKP(M,K+1), YP(M), RABC(K2), HD4I(K2+1),
     3          ALP (K), ALPN(K),  CMAR(K,K),   P((K+2)*(K-1)/2),
     4          ALP2(K2),ALPN2(K2),CMAR2(K2,K2),S((K+3)*K/2),
     5          U(M,K),U2(M,K2),DELTY(M),RO(M), ZFI(M,K+4), ZFI2(M,K2+3)
C
      COMMON/COM70D/WC1,WC2,WC3,LASN,HD2,HD4,HOLD
      COMMON/COM75D/LASN0,LASN2,WC30,WC12,WC22,WC32
      COMMON/STAT76/NACCEP,NREJEC
      COMMON/BLOCK/N,Q
      DOUBLE PRECISION Q,Y,YT,XK      
C
      EXTERNAL F
C
      M0=M
      Q=4.0D0
      N=0
      NREJEC=0
      NACCEP=0
C
      X=0.
      Y=EXP(Q)
      XK=7.D0
      K0=K
      INIAPR=1
      IMAX=28
      IU=2
      EPS=0.5D-11
      THRESH=1.D0
      MEXACT=1
      MESTER=1
      H=1.D0
      HMIN=1.D-3
      K20=K2
      IMAX2=3
      NATTEM=3
C
      JSTART=0
      BUL=.FALSE.
      DO 20 NX=1,5
      PRINT 54,JSTART
      CALL DE75D(F,M0,K0,INIAPR,IMAX,JSTART,Y,X,IU,EPS,THRESH,     
     1                 H,HMIN,BUL,XP,YP,MEXACT,NUMBES,DELTY,RO,MESTER,
     2                 K20,IMAX2,YX2,NATTEM,AU,AJK,AU2,AJK2,XJ0,XJ02,
     3                 AJKP,U,U2,ZFI,ZFI2,HD4I,RABC,
     4                 ALP,ALPN,CMAR,P,S,ALP2,ALPN2,CMAR2,IERR)         
C
C
C
      YT=EXP(Q*(X+1.D0))
      PRINT 44,NX
      PRINT 50,IERR,N,NACCEP,NREJEC,BUL
      PRINT 51,XP,X
      PRINT 35, H,K0,INIAPR,IMAX,JSTART,K20,IMAX2
      PRINT 36, H
      PRINT 52,Y,YT,(YT-Y)/Y
C
      PRINT 110,NX
      DO 10 L=1,M
      PRINT 47
      PRINT 150,L
      PRINT 85,(J-1,AU(L,J),AJK(L,J),J=1,K0+1), K0+1,AU(L,K0+2)
   10 CONTINUE
C
      PRINT 55
      IF (NX .NE. 4) GO TO 20
C
      H=XK-X
      BUL=.TRUE.
   20 CONTINUE
C
      STOP
C
   35 FORMAT(1X,'H =',D25.16,3X,'K =',I2,3X,'INIAPR=',I1,3X,'IMAX =',I2,
     1       3X,'JSTART (exit) =',I1/1X,31X,'K2=',I2,13X,' IMAX2=',I2)
   36 FORMAT(1X,'It is advisable to take the next segment H = ',D22.16/)
   44 FORMAT(/1X,'RESULTS AFTER ',I1,'-nd    CALL SUBROUTINE DE75D'//)
   47 FORMAT(1X,64(1H-)/)
   50 FORMAT(1X,'IERR=',I2,3X,'N=',I5,3X,'NACCEP=',I3,3X,'NREJEC=',I3,
     1           3X,'BUL=',L3)
   51 FORMAT(1X,'XP=',D25.16,5X,'X=',D25.16)
   52 FORMAT(1X,'Y =',D25.16/1X,'YT=',D25.16/1X,'(YT-Y)/Y=',D25.16/)
   53 FORMAT(1X,'It is advisable to take the next elementary segment '
     1         'equal to '/1X,' H=',D25.16)    
   54 FORMAT(1X,'JSTART (input) =',I1)
   55 FORMAT(1X,64(1H*)/)
   85 FORMAT(5X,I2,5X,2D25.16)
  110 FORMAT(/12X,'COEFFICIENTS AU AND AJK ON ',I3,'  SEGMENT  ')
C      
  150 FORMAT('   Number of',7X,'Chebyshev coefficients'
     *       ' for ',I1,' component'/  
     1        14X,51(1H-)/
     2       ' coefficient',11X,'for Y',21X,'for Y'''/         
     3        1X,64(1H-)/)
C   
      END
C         
C
      SUBROUTINE F(X,Y,Z,M)
      DOUBLE PRECISION X,Y,Z,Q
      COMMON/BLOCK/N,Q
      Z=Q*Y
      N=N+1
      RETURN
      END

              
